#ifndef _MAR_STRINGS_HPP
#define _MAR_STRINGS_HPP

/***********************************************************************

               M a r c i n   W u d a r c z y k 's NonameLib

                           Freeware  library

                            Data Structures

ver 0.9 Beta

                            USE AT OWN RISK
               More info you can find in file libread.txt

          (c) 1999 Marcin Wudarczyk
***********************************************************************/


#include <check.hpp>
#include <_defs.h>
#include <string.h>
#include <iostream.h>
#include <stdlib.h>
#include <stdio.h>

#if defined(__VCLSTRING__) || defined(__VCL__)
#	include <vcl\system.hpp>
#endif

#ifdef __BCPPB__
#pragma option push
#endif

#pragma warn -sig

#ifdef __BCPPB__
namespace mar {
#endif

template<class Tw, class Tr> class smpvctri {
	public:
		class proplen {
			friend class smpvctri;
			private:
				Tw s;

				char *& gets() { return s; }

			public:
				proplen() {}
				proplen(Tw s) : s(s) {}

				operator word() const { return s ? strlen(s) : 0; }
				word operator()() const { return me; }
		} len;

		#define s (len.gets())
	protected:
		Tw str() { return s; }

	public:
		smpvctri() : len(0) {}
		smpvctri(Tw co) : len(co) {}

		typedef Tw itr;
		typedef itr iterator;

		operator Tw &() const { return str(); }
};



#undef s
template<class Tw, class Tr> class datastri;

template<class Tw, class Tr> class inplacedatastri: public smpvctri<Tw, Tr> {
	private:
		static word line;
	public:
		inplacedatastri():smpvctri<Tw, Tr>() {}
		inplacedatastri(Tw co):smpvctri<Tw, Tr>(co) {}


		inplacedatastr(const char co,const word ile=1) {
			check(s=new char[ile+1]);
			memset(s,co,ile);
			s[ile]=0;
		}
		inplacedatastri(word  co) { check(s=new char[co+1]);s[co]=0;}
		inplacedatastri(int   co) { check(s=new char[co+1]);s[co]=0;}
		inplacedatastri(byte  co) { check(s=new char[co+1]);s[co]=0;}
		inplacedatastri(dword co) { check(s=new char[co+1]);s[co]=0;}
		inplacedatastri(long  co) { check(s=new char[co+1]);s[co]=0;}

		inplacedatastri &swap(inplacedatastri &co) {
			Tw *p=co.s;
			co.s=s;
			s=p;
			return me;
		}

		inplacedatastri insert (word w,const inplacedatastri &co,word odkad,word ile) const {
			inplacedatastri out(word(ile+len()-odkad));
			memcpy(out,s,w);
			memcpy(out+w,co+odkad,ile);
			strcpy(out+w+ile,s+w);
			return out;
		}
		inplacedatastri &insert_(word w,const inplacedatastri &co,word odkad,word ile) {
			inplacedatastri out=(word)(ile+len()-odkad);
			memcpy(out,s,w);
			memcpy(out+w,co+odkad,ile);
			strcpy(out+w+ile,s+w);
			swap(out);
			return *this;
		}

		inplacedatastri mid(word start,word ile) const {
			inplacedatastri out=ile;
			memcpy(out,s+start,ile);
			return out;
		}
		inplacedatastri &mid_(word start,word ile) {
			inplacedatastri out=ile;
			memcpy(out,s+start,ile);
			swap(out);
			return *this;
		}

		inplacedatastri get(word skad,word dokad) const {
			if (skad>dokad || !len()) return inplacedatastri();
			inplacedatastri out=word(dokad-skad+1);
			memcpy(out,s+skad,dokad-skad+1);
			return out;
		}
		inplacedatastri &get_(word skad,word dokad) {
			if (skad>dokad) return *this=inplacedatastri();
			inplacedatastri out=word(dokad-skad+1);
			memcpy(out,s+skad,dokad-skad+1);
			swap(out);
			return *this;
		}

		inplacedatastri insert (word w,const inplacedatastri &co,word odkad=0) const {
			word ile=co.len();
			inplacedatastri out(word(ile+len()-odkad));
			memcpy(out,s,w);
			memcpy(out+w,co+odkad,ile);
			strcpy(out+w+ile,s+w);
			return out;
		}
		inplacedatastri &insert_(word w,const inplacedatastri &co,word odkad=0) {
			word ile=co.len();
			inplacedatastri out=(word)(ile+len()-odkad);
			memcpy(out,s,w);
			memcpy(out+w,co+odkad,ile);
			strcpy(out+w+ile,s+w);
			swap(out);
			return *this;
		}

		inplacedatastri mid(word start=0) const {
			word ile=len()-start;
			inplacedatastri out=ile;
			memcpy(out,s+start,ile);
			return out;
		}
		inplacedatastri &mid_(word start=0) {
			word ile=len()-start;
			inplacedatastri out=ile;
			memcpy(out,s+start,ile);
			swap(out);
			return *this;
		}

		inplacedatastri get(word skad) const {
			word dokad=len();
			if (skad>dokad || !len()) return inplacedatastri();
			inplacedatastri out=word(dokad-skad+1);
			memcpy(out,s+skad,dokad-skad+1);
			return out;
		}
		inplacedatastri &get_(word skad) {
			word dokad=len();
			if (skad>dokad) return *this=inplacedatastri();
			inplacedatastri out=word(dokad-skad+1);
			memcpy(out,s+skad,dokad-skad+1);
			swap(out);
			return *this;
		}

		inplacedatastri left(word ile) const {
			inplacedatastri out=ile;
			memcpy(out,s,ile);
			return out;
		}
		inplacedatastri &left_(word ile) {
			inplacedatastri out=ile;
			memcpy(out,s,ile);
			swap(out);
			return *this;
		}

		inplacedatastri right(word ile) const  {
			inplacedatastri out=ile;
			memcpy(out,s+len()-ile,ile);
			return out;
		}
		inplacedatastri &right_(word ile) {
			inplacedatastri out=ile;
			memcpy(out,s+len()-ile,ile);
			swap(out);
			return *this;
		}

		inplacedatastri leftr(word ile) const {
			inplacedatastri out=word(len()-ile);
			memcpy(out,s,len()-ile);
			return out;
		}
		inplacedatastri &leftr_(word ile) {
			inplacedatastri out=word(len()-ile);
			memcpy(out,s,len()-ile);
			swap(out);
			return *this;
		}

		inplacedatastri rightr(word ile) const  {
			inplacedatastri out=word(len()-ile);
			memcpy(out,s+ile,len()-ile);
			return out;
		}
		inplacedatastri &rightr_(word ile) {
			inplacedatastri out=word(len()-ile);
			memcpy(out,s+ile,len()-ile);
			swap(out);
			return *this;
		}

		inplacedatastri put(word w,const inplacedatastri &co,word odkad=0,word ile=65535u) const {
			if (ile==65535u) ile=len()-w<co.len()-odkad?len()-w:co.len()-odkad;
			inplacedatastri out=*this;
			memcpy(out+w,co+odkad,ile);
			return out;
		}
		inplacedatastri &put_(word w,const inplacedatastri &co,word odkad=0,word ile=65535u) {
			if (ile==65535u) ile=len()-w<co.len()-odkad?len()-w:co.len()-odkad;
			memcpy(s+w,co+odkad,ile);
			return *this;
		}

		inplacedatastri fill(char czym,word w=0,word ile=65535u) const {
			if (ile==65535u) ile=len()-w;
			inplacedatastri out=*this;
			memset(out+w,czym,ile);
			return out;
		}
		inplacedatastri &fill_(char czym,word w=0,word ile=65535u) {
			if (ile==65535u) ile=len()-w;
			memset(s+w,czym,ile);
			return *this;
		}

		inplacedatastri &del(word w=0,word ile=65535u) {
			if (ile==65535u) ile=len()-w;
			inplacedatastri out=word(len()-ile);
			memcpy(out,s,w);
			memcpy(out+w,s+w+ile,len()-ile-w);
			swap(out);
			return *this;

		}
		inplacedatastri &cut(word w=0,word dokad=65535u) {
			if (dokad==65535u) dokad=len();
			inplacedatastri out=word(len()-dokad+w-1);
			memcpy(out,s,w);
			memcpy(out+w,s+dokad+1,len()-dokad+w-1);
			swap(out);
			return *this;
		}

		inplacedatastri &operator=(const inplacedatastri &co) {
/*			if (&co!=this) {
				delete s;
				check(s=new char[co.len()+1]);
				strcpy(s,co);
			}            */
			s = co.s;
			return me;
		}

		inplacedatastri &operator=(const char *co) {
/*			delete s;
			check(s=new char[strlen(co)+1]);
			memcpy(s,co,strlen(co)+1);*/
			s = co.s;
			return me;
		}


		bool operator==(const inplacedatastri &co) const { return !strcmp(s,co); }
		bool operator!=(const inplacedatastri &co) const { return  strcmp(s,co); }
		bool operator==(const char *co) const { return !strcmp(s,co); }
		bool operator!=(const char *co) const { return  strcmp(s,co); }

		inplacedatastri operator+(const inplacedatastri &co) const {
			inplacedatastri out=word(co.len()+len());
			memcpy(out,s,len());
			memcpy(out+len(),co,co.len());
			return out;
		}
		inplacedatastri &operator+=(const inplacedatastri &co) {
			inplacedatastri out=word(co.len()+len());
			memcpy(out,s,len());
			memcpy(out+len(),co,co.len());
			swap(out);
			return *this;
		}

		inplacedatastri operator-(word ile) const {
			inplacedatastri out=word(len()-ile);
			memcpy(out,s,len()-ile);
			return out;
		}
		inplacedatastri &operator-=(word ile) {
			inplacedatastri out=word(len()-ile);
			memcpy(out,s,len()-ile);
			swap(out);
			return *this;
		}





};


class _CLASSTYPE string {
	public:

		static word line;

		class proplen {
			private:
				char *s;
			public:
				proplen() {}
				proplen(char *s) : s(s) {}

				operator word() const { return s ? strlen(s) : 0; }
				word operator()() const { return me; }

				char *& gets() const { return (char *)s; }
		} len;

	#define s len.gets()

	public:
		operator char*&() const { return (char*)s; }
//		operator char*&() { return s; }

		string() { s=0; }
		string(const char *co) {
			check(s=new char[strlen(co)+1]);
			_fmemcpy(s,co,strlen(co)+1);
		}
		string(const string &co) {
			check(s=new char[co.len()+1]);
			_fmemcpy(s,co,co.len()+1); // bo blad w strcpy: zle kopiuje string zerowy
		}
		string(const char co,const word ile=1) {
			check(s=new char[ile+1]);
			memset(s,co,ile);
			s[ile]=0;
		}
		string(word co) { check(s=new char[co+1]);s[co]=0;}
		string(int co) { check(s=new char[co+1]);s[co]=0;}
		string(byte co) { check(s=new char[co+1]);s[co]=0;}
		string(dword co) { check(s=new char[co+1]);s[co]=0;}
		string(long co) { check(s=new char[co+1]);s[co]=0;}
		~string() { delete s; }

//		word len() const { return strlen(s); }
//		char  *ch() const;
		long     val() const;
		void swap(string &co) {
			char *p=s;
			s=co.s;
			co.s=p;
		}

		string insert (word w,const string &co,word odkad,word ile) const {
			string out(word(ile+len()-odkad));
			memcpy(out,s,w);
			memcpy(out+w,co+odkad,ile);
			strcpy(out+w+ile,s+w);
			return out;
		}
		string &insert_(word w,const string &co,word odkad,word ile) {
			string out=(word)(ile+len()-odkad);
			memcpy(out,s,w);
			memcpy(out+w,co+odkad,ile);
			strcpy(out+w+ile,s+w);
			swap(out);
			return *this;
		}

		string mid(word start,word ile) const {
			string out=ile;
			memcpy(out,s+start,ile);
			return out;
		}
		string &mid_(word start,word ile) {
			string out=ile;
			memcpy(out,s+start,ile);
			swap(out);
			return *this;
		}

		string get(word skad,word dokad) const {
			if (skad>dokad || !len()) return string();
			string out=word(dokad-skad+1);
			memcpy(out,s+skad,dokad-skad+1);
			return out;
		}
		string &get_(word skad,word dokad) {
			if (skad>dokad) return *this=string();
			string out=word(dokad-skad+1);
			memcpy(out,s+skad,dokad-skad+1);
			swap(out);
			return *this;
		}

		string insert (word w,const string &co,word odkad=0) const {
			word ile=co.len();
			string out(word(ile+len()-odkad));
			memcpy(out,s,w);
			memcpy(out+w,co+odkad,ile);
			strcpy(out+w+ile,s+w);
			return out;
		}
		string &insert_(word w,const string &co,word odkad=0) {
			word ile=co.len();
			string out=(word)(ile+len()-odkad);
			memcpy(out,s,w);
			memcpy(out+w,co+odkad,ile);
			strcpy(out+w+ile,s+w);
			swap(out);
			return *this;
		}

		string mid(word start=0) const {
			word ile=len()-start;
			string out=ile;
			memcpy(out,s+start,ile);
			return out;
		}
		string &mid_(word start=0) {
			word ile=len()-start;
			string out=ile;
			memcpy(out,s+start,ile);
			swap(out);
			return *this;
		}

		string get(word skad) const {
			word dokad=len();
			if (skad>dokad || !len()) return string();
			string out=word(dokad-skad+1);
			memcpy(out,s+skad,dokad-skad+1);
			return out;
		}
		string &get_(word skad) {
			word dokad=len();
			if (skad>dokad) return *this=string();
			string out=word(dokad-skad+1);
			memcpy(out,s+skad,dokad-skad+1);
			swap(out);
			return *this;
		}

		string left(word ile) const {
			string out=ile;
			memcpy(out,s,ile);
			return out;
		}
		string &left_(word ile) {
			string out=ile;
			memcpy(out,s,ile);
			swap(out);
			return *this;
		}

		string right(word ile) const  {
			string out=ile;
			memcpy(out,s+len()-ile,ile);
			return out;
		}
		string &right_(word ile) {
			string out=ile;
			memcpy(out,s+len()-ile,ile);
			swap(out);
			return *this;
		}

		string leftr(word ile) const {
			string out=word(len()-ile);
			memcpy(out,s,len()-ile);
			return out;
		}
		string &leftr_(word ile) {
			string out=word(len()-ile);
			memcpy(out,s,len()-ile);
			swap(out);
			return *this;
		}

		string rightr(word ile) const  {
			string out=word(len()-ile);
			memcpy(out,s+ile,len()-ile);
			return out;
		}
		string &rightr_(word ile) {
			string out=word(len()-ile);
			memcpy(out,s+ile,len()-ile);
			swap(out);
			return *this;
		}

		string put(word w,const string &co,word odkad=0,word ile=65535u) const {
			if (ile==65535u) ile=len()-w<co.len()-odkad?len()-w:co.len()-odkad;
			string out=*this;
			memcpy(out+w,co+odkad,ile);
			return out;
		}
		string &put_(word w,const string &co,word odkad=0,word ile=65535u) {
			if (ile==65535u) ile=len()-w<co.len()-odkad?len()-w:co.len()-odkad;
			memcpy(s+w,co+odkad,ile);
			return *this;
		}

		string fill(char czym,word w=0,word ile=65535u) const {
			if (ile==65535u) ile=len()-w;
			string out=*this;
			memset(out+w,czym,ile);
			return out;
		}
		string &fill_(char czym,word w=0,word ile=65535u) {
			if (ile==65535u) ile=len()-w;
			memset(s+w,czym,ile);
			return *this;
		}

		string &del(word w=0,word ile=65535u) {
			if (ile==65535u) ile=len()-w;
			string out=word(len()-ile);
			memcpy(out,s,w);
			memcpy(out+w,s+w+ile,len()-ile-w);
			swap(out);
			return *this;

		}
		string &cut(word w=0,word dokad=65535u) {
			if (dokad==65535u) dokad=len();
			string out=word(len()-dokad+w-1);
			memcpy(out,s,w);
			memcpy(out+w,s+dokad+1,len()-dokad+w-1);
			swap(out);
			return *this;
		}

		string &operator=(const string &co) {
			if (&co!=this) {
				delete s;
				check(s=new char[co.len()+1]);
				strcpy(s,co);
			}
			return *this;
		}

		string &operator=(const char *co) {
			delete s;
			check(s=new char[strlen(co)+1]);
			memcpy(s,co,strlen(co)+1);
			return *this;
		}


		bool operator==(const string &co) const { return !strcmp(s,co); }
		bool operator!=(const string &co) const { return  strcmp(s,co); }
		bool operator==(const char *co) const { return !strcmp(s,co); }
		bool operator!=(const char *co) const { return  strcmp(s,co); }

		string operator+(const string &co) const {
			string out=word(co.len()+len());
			memcpy(out,s,len());
			memcpy(out+len(),co,co.len());
			return out;
		}
		string &operator+=(const string &co) {
			string out=word(co.len()+len());
			memcpy(out,s,len());
			memcpy(out+len(),co,co.len());
			swap(out);
			return *this;
		}

		string operator-(word ile) const {
			string out=word(len()-ile);
			memcpy(out,s,len()-ile);
			return out;
		}
		string &operator-=(word ile) {
			string out=word(len()-ile);
			memcpy(out,s,len()-ile);
			swap(out);
			return *this;
		}

		char& operator[](word co) const { return s[co]; }

		char *operator+(word co) const { return s+co; }

		string operator()(word tart,word ile) const { return mid(tart,ile); }

		friend string   operator+ (const string &co,const char *co2);
		friend string   operator+ (const char *co,const string &co2);

		friend ostream& operator<<(ostream &out,const string &co) ;
		friend istream& operator>>(istream &in,string& co);

		friend bool operator==(const char *co,const string &co2);
		friend bool operator!=(const char *co,const string &co2);

		friend word operator-(char *, const string &);
		friend word operator-(const string &, char *);

		word operator-(const string &co) { return s-co.s; }

		//operator word () const;

		static string *newobject(word ile=1) { return check(new string[ile]); }

};

inline word operator-(char *co, const string &w) { return co-w.s; }
inline word operator-(const string &co, char *w) { return co.s-w; }


inline bool operator==(const char *co,const string &co2) { return !strcmp(co,co2); }
inline bool operator!=(const char *co,const string &co2) { return  strcmp(co,co2); }


inline string str(const dword co,byte radix=10) {
	string out(word(32u));
	ultoa(co,out,radix);
	return out.left(out.len());
}

inline string str(const long co,byte radix=10) {
	string out(word(32u));
	ltoa(co,out,radix);
	return out.left(out.len());
}

inline string str(const int co,byte radix=10) {
	string out(word(32u));
	itoa(co,out,radix);
	return out.left(out.len());
}

#undef s


	/*
		err
		0 - brak
		1 - bd alokacji
	*/


template<word size> class smallstr {
	public:

		class proplen {
			friend smallstr<size>;
			private:
				char s[size +1];

			public:
				proplen() {}

				operator word()   { return strlen(s); }
				word operator()() { return strlen(s); }
		} len;

		#define str (len.s)

		smallstr() { *str=0; }

		#ifdef __BCPPB__
		template <word s2>
			smallstr(const smallstr<s2> &co) {
				strncpy(str, co, size)[size]=0;
			}
		#endif

		smallstr(const string &co) {
			strncpy(str, co, size)[size]=0;
		}

		smallstr(const char *co) {
			strncpy(str, co, size)[size]=0;
		}

	#ifdef DSTRING_H
		template<word s2>
			smallstr(const SmallString<s2> &co) {
				if (!memccpy(str, &co[0], 0, size))
					str[size] = 0;
			}

		smallstr(const AnsiString &co) {
			strncpy(str, co.c_str(), size)[size]=0;
		}

		operator AnsiString() const {
			return AnsiString(str);
		}

		template<word s2>
			operator SmallString<s2>() const {
				return SmallString(str);
			}


		operator Variant() const{ return Variant(str); }

		bool operator==(const AnsiString &co) const { return !strcmp(str, co.c_str() ); }
		bool operator!=(const AnsiString &co) const { return  strcmp(str, co.c_str() ); }


	#endif

	#ifdef __BCPPB__
		template<word s2>
			smallstr<size> &operator=(const smallstr<s2> &co) {
				if (&co != this)
					strncpy(str, co, size)[size]=0;

				return me;
			}
	#endif

		smallstr<size> &operator=(const string &co) {
			strncpy(str, co, size)[size]=0;

			return me;
		}

		smallstr<size> &operator=(const char *co) {
			if (co != str) strncpy(str, co, size)[size] = 0;
			return me;
		}


		char& operator[](word co) const { return (char &)str[co]; }
		char& operator*() const { return *(char *)str; }
		operator char *() const { return (char *)str; }


		#ifdef __BCPPB__
		template<word s2>
			bool operator==(const smallstr<s2> &co) const { return !strcmp(str, co); }
		template<word s2>
			bool operator!=(const smallstr<s2> &co) const { return !strcmp(str, co); }
		#endif

		bool operator==(const string &co) const { return !strcmp(str, co); }
		bool operator!=(const string &co) const { return  strcmp(str, co); }

		bool operator==(const char *co) const { return !strcmp(str, co); }
		bool operator!=(const char *co) const { return  strcmp(str, co); }

		smallstr<size> operator+(const char *co) {
			smallstr<size> out = me;
			dword sz = strlen(str);
			strncpy(out.len.s + sz, co, size - sz);
			out.len.s[size]=0;
			return out;
		}

		#undef str

		static word ssize() { return size; }

};

typedef smallstr<16> smallstr16;
typedef smallstr<32> smallstr32;
typedef smallstr<64> smallstr64;
typedef smallstr<50> smallstr50;
typedef smallstr<255> smallstr255;



template<word size> class pswdsstr /*: public smallstr<size> */ /* ctors do not work */ {
	private:
		char s[size+1];
	public:
		word len() const { return strlen(s); }
		word ssize() const { return size; }

		operator char *&() const { return (char *&)s; }

		pswdsstr()/* : smallstr<size>() */ {}

		#ifdef __BCPPB__
/*		template <word s2>
			pswdsstr(const smallstr<s2> &co) : smallstr<size>(co) {
//				word l = len(); memset(me + l, 0, size - l +1);
			}
		template <word s2>
			pswdsstr(const pswdsstr<s2> &co) {
				memcpy(me, co, size+1);
			}*/
		#endif
		pswdsstr(const pswdsstr<size> &co) {
			memcpy(me, co, size+1);
		}

		pswdsstr(const char *co) {
			strncpy(me, co, size)[size]=0;
		}


/*		pswdsstr(const string &co) : smallstr<size>(co) {
//			word l = len(); memset(me + l, 0, size - l +1);
		}

		pswdsstr(const char *co) {
			memcpy(me, co, size+1);
//			word l = len(); memset(me + l, 0, size - l +1);
		}

		#ifdef DSTRING_H
		template<word s2>
			pswdsstr(const SmallString<s2> &co) : smallstr<size>(co) {
//				word l = len(); memset(me + l, 0, size - l +1);
			}

		pswdsstr(const AnsiString &co) : smallstr<size>(co) {
//			word l = len(); memset(me + l, 0, size - l +1);
		}
		#endif*/

		#ifdef __BCPPB__
		template<word s2>
			bool operator==(const pswdsstr<s2> &co) const { return !memcmp(me, co, size+1); }
		template<word s2>
			bool operator!=(const pswdsstr<s2> &co) const { return  memcmp(me, co, size+1); }
		#endif
		bool operator==(const char *co) const { return !strcmp(me, co); }
		bool operator!=(const char *co) const { return  strcmp(me, co); }

		#ifdef __BCPPB__
		template<word s2>
			pswdsstr<size> &operator=(const pswdsstr<s2> &co) {
				memcpy(me, co, size+1);
				return me;
			}
		#endif
		pswdsstr<size> &operator=(const pswdsstr<size> &co) {
			memcpy(me, co, size+1);
			return me;
		}
		pswdsstr<size> &operator=(const char *co) {
			memcpy(me, co, size+1);
			return me;
		}

};


#ifdef __BCPPB__
} // namespace mar

using namespace mar;

#endif

#ifdef __BCPPB__
#	pragma option pop
#else
#	pragma warn .sig
#endif

#endif

