//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop

//#include "SecuredFormUnit.h"
#include "rights.h"
#include <s.h>
#include <stdlib.h>
#include "Main.h"

#ifndef __BORLANDCPPB5__
#	define DBProvStr "MarVic:BDE:Vcl4"
#else
#	define DBProvStr "MarVic:BDE:Vcl5"
#endif


USERES("SecurityTest.res");
USEFORM("Main.cpp", MainFrm);
USEFORM("SecuredFormUnit.cpp", SecuredForm);
USEFORM("DBProvFrame.cpp", DBProvFrameFrm); /* TFrame: File Type */
//---------------------------------------------------------------------------
PswdString __stdcall Encode(const char *a,const char *b) {
	byte t[17] = { 149, 51, 231, 178, 97, 119, 227, 137, 193, 73, 209, 154, 218, 175, 165, 13, 247 };

	if (! *b) b = (char *)t;
	//word l=min( strlen(a), strlen(b) );
	char out2[17];
	word i;
	for(i=0; i<16; ++i)
		out2[i]=word( word( a[i] | b[i] ) + i*113) % 96 + 32;

	out2[16]=0;
	return out2;
}


WINAPI WinMain(HINSTANCE, HINSTANCE, LPSTR, int)
{
	try
	{
		Application->Initialize();
		Application->ShowHint=1;


//		Application->CreateHandle();


		TSecRights::AddSecurity( "BDE_ODBC_JET", "SecurityTest",
			DBProvStr, "BDE", "RecordsetStoredProcs=0, CachedUpdates=1, BDESQLParams=1",
			"SecurityCheck", "SCszklanka",
			"Application was not able to connect to Security database. Quitting.",
			"You cannot run this program without valid user and password. Press OK to try again or Cancel to exit the program.",
			"Invalid login", "SecurityTest BDE", 0, false);


		TSecRights::AddSecurity( "BDE_DAO_JET", "SecurityTest2",
			DBProvStr, "BDE", "RecordsetStoredProcs=0, CachedUpdates=1, BDESQLParams=0",
			"SecurityCheck", "SCszklanka",
			"Application was not able to connect to Security database. Quitting.",
			"You cannot run this program without valid user and password. Press OK to try again or Cancel to exit the program.",
			"Invalid login", "SecurityTest BDE", 0, false);


//Provider=MSDASQL.1;Persist Security Info=True;User ID=%s;Password=%s;Data Source=SecurityTest
//Provider=Microsoft.Jet.OLEDB.4.0;User ID=%s;Password=%s;Data Source=C:\\MARCIN\\CppBuilder\\Security\\DATA\\Security.mdb;Persist Security Info=True;Jet OLEDB:System database=C:\\MARCIN\\CppBuilder\\Security\\DATA\\Security.mdw
		TSecRights::AddSecurity( "ADO_OLEDB_ODBC_JET", "Provider=MSDASQL.1;Persist Security Info=True;User ID=%s;Password=%s;Data Source=SecurityTest",
			"MarVic:ADO:Vcl5", "ADO", "LocalCursor=1, BatchUpdates=1",
			"SecurityCheck", "SCszklanka",
			"Application was not able to connect to Security database. Quitting.",
			"You cannot run this program without valid user and password. Press OK to try again or Cancel to exit the program.",
			"Invalid login", "SecurityTest ADO", 0, false);


		TSecRights::AddSecurity( "ADO_OLEDB_JET", "Provider=Microsoft.Jet.OLEDB.4.0;User ID=%s;Password=%s;Data Source=C:\\MARCIN\\CppBuilder\\Security\\DATA\\Security.mdb;Persist Security Info=True;Jet OLEDB:System database=C:\\MARCIN\\CppBuilder\\Security\\DATA\\Security.mdw",
			"MarVic:ADO:Vcl5", "ADO", "LocalCursor=1, BatchUpdates=1",
			"SecurityCheck", "SCszklanka",
			"Application was not able to connect to Security database. Quitting.",
			"You cannot run this program without valid user and password. Press OK to try again or Cancel to exit the program.",
			"Invalid login", "SecurityTest ADO", 0, false);

		Application->Title = "SecurityTest";
		Application->CreateForm(__classid(TMainFrm), &MainFrm);
		TSecRights::SetAppHWnd(Application->MainForm->Handle);
		MainFrm->Show();




		Application->Run();

		//TSecRights::DeleteSecurity("SecurityTest");

		Application->Terminate();
	}
	catch (Exception &exception)
	{
		Application->ShowException(&exception);
	}
	catch (ESecExcept) {
		Application->Terminate();
	}
	return 0;
}
//---------------------------------------------------------------------------
