//---------------------------------------------------------------------------


#ifndef DBProvFrameH
#define DBProvFrameH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include <vcls.h>


class TMainFrm;
//---------------------------------------------------------------------------
class TDBProvFrameFrm : public TFrame
{
__published:	// IDE-managed Components
	TEdit *SecUser;
	TComboBox *DBProv;
	TButton *Login;
	TButton *Logout;
	TButton *SmallDlg;
	TButton *SecurityAdm;
	void __fastcall LoginClick(TObject *Sender);
	void __fastcall LogoutClick(TObject *Sender);
	void __fastcall SmallDlgClick(TObject *Sender);
	void __fastcall SecurityAdmClick(TObject *Sender);
	void __fastcall DBProvClick(TObject *Sender);

private:	// User declarations
	TSecRights Rights;
	void __fastcall SetDBProvIndex(int value);
	int __fastcall GetDBProvIndex();
public:		// User declarations
	typedef TFrame inherited;

	__fastcall TDBProvFrameFrm(TComponent* Owner);
	__property int DBProvIndex  = { read=GetDBProvIndex, write=SetDBProvIndex };
	redefpropex(public, TMainFrm *, Parent, TWinControl *);
};
//---------------------------------------------------------------------------
extern PACKAGE TDBProvFrameFrm *DBProvFrameFrm;
//---------------------------------------------------------------------------
#endif
