//---------------------------------------------------------------------------
#ifndef SecuredFormUnitH
#define SecuredFormUnitH
#define __SSPI_H__
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include "Rights.h"

//---------------------------------------------------------------------------


class TSecuredForm : public TForm
{

private:	// User declarations
	TNotifyEvent FOnRightsRead;

protected:
	void __fastcall ReadRights();
	virtual void __fastcall RightsRead();
	TSecRights Rights;

__published:

public:

	__fastcall TSecuredForm(TComponent* Owner);
	__fastcall TSecuredForm(TComponent* Owner, char *name);

	__property TNotifyEvent OnRightsRead = { read = FOnRightsRead, write = FOnRightsRead };

	bool Bind(const char *secname) { Rights.Bind(secname); return Rights.Binded(); }
};
//---------------------------------------------------------------------------


//---------------------------------------------------------------------------
#endif
